/*==========================================================================
       RS485,       NL.   - ,    . 
   -   :
: $AA2/r
:
$ -    ;
AA- ;
2-  ;
/r-  ( 0x0D);
: !AATTCCFF/r
:
!-   ;
AA- ;
TT- ;
-  ;
FF- ;
    ,          NL.

     1  255   ,        .       COM1, 
   9600 /        DCON   .
==========================================================================*/

#define F_CPU 14745600UL																		//    

#include "MC12D4R4O.h"																			// 
//#include "MC8D2S2R.h"
//#include "MC4A7D4R4O.h"
//#include "MC12D8O.h"

#define COM_RX_BUFFER_SIZE 32																	//   
#define COM_TX_BUFFER_SIZE 32																	//   

#define COM1_PROTOCOL DCON																		//   COM1  DCON

#include <avr/io.h>																				//  -
#include "LED.h"																				//   LED 
#include "COM.h"																				//   RS485

//-----------------------------------  RAM ----------------------------------------
char buf[16];																					// 
uint8_t temp;																					// 
uint8_t Find_Ok;																				//    (   )
uint8_t Addres=0x01;																			//   
char char2[2];																					//     

//---------------------------------------------------------------------------------------------
//============        ============
//---------------------------------------------------------------------------------------------
void hex_to_char2(char s1)
{
	char temp;																					// 
	
	temp=s1>>4;
	if (temp<=9) char2[0]=temp+0x30;															//    (0-9)
	else char2[0]=temp+0x37;																	//    (A-F)
	temp=s1 & 0x0F;
	if (temp<=9) char2[1]=temp+0x30;															//    (0-9)
	else char2[1]=temp+0x37;																	//    (A-F)
}

//---------------------------------------------------------------------------------------------
//===================================   ======================================
//---------------------------------------------------------------------------------------------
int main(void)
{
	_delay_ms(1000);																			//       
	
	LED_Init();																					// 
	COM_Init(COM_PORT1,9600);																	// COM 

	//---------------------------------    -----------------------------------
	LED_SetPos(0,0);																			//      
	Find_Ok=0;																					//   
	while((Find_Ok==0) && (Addres!=0x00))														//     ,      
	{
		buf[0]='$';																				// 
		hex_to_char2(Addres);																	//     
		buf[1]=char2[0];
		buf[2]=char2[1];
		buf[3]='2';
		buf[4]=0;																				//    (   0x0D)
		
		Write_DCON(COM_PORT1,buf);																//   RS485
		_delay_ms(200);																			//  
		if (Read_DCON(COM_PORT1,buf)==1)														//  
		{
			temp=buf[0];																		//   
			buf[temp]=0;																		//      (        )
			Find_Ok=1;																			//   
			LED_Write_String(&buf[1]);															//    
		}
		Addres++;																				//     
	}
	

	//---------------------------------    -----------------------------------
	LED_SetPos(1,0);																			//      
	Find_Ok=0;																					//   
	while((Find_Ok==0) && (Addres!=0x00))														//     ,      
	{
		buf[0]='$';																				// 
		hex_to_char2(Addres);																	//     
		buf[1]=char2[0];
		buf[2]=char2[1];
		buf[3]='2';
		buf[4]=0;																				//    (   0x0D)
		
		Write_DCON(COM_PORT1,buf);																//   RS485
		_delay_ms(200);																			//  
		if (Read_DCON(COM_PORT1,buf)==1)														//  
		{
			temp=buf[0];																		//   
			Find_Ok=1;																			//      (        )
			buf[temp]=0;																		//   
			LED_Write_String(&buf[1]);															//    
		}
		Addres++;																				//     		
	}
	Led(LD_ON);																					// 
}

