#ifndef _SHIM_																				//    
#define _SHIM_

#include <avr/iom128.h>																		//  /
#include "IOPort.h"																			//    -

#include "Timer2.h"																			//      2

//=================================    ====================================
// :
//Cannel- 
//Pulse-  
//Period-  
// :
//0x00-    ,    0xFF

char Shim(int Cannel, unsigned int Pulse, unsigned int Period)
{
	if (Period>1000) return 0xFF;															//    10 ,   
	if (Pulse>Period) return 0xFF;															//     
	
	_ShimPeriod[Cannel]=Period;																//  
	_ShimPulse[Cannel]=Pulse;
	
	switch (Cannel)
	{
	case 0:
		DDRB|=(1<<PB4);																		//    
		if (Pulse!=0) PORTB|=(1<<PB4);														//  ,    
		else PORTB&=~(1<<PB4);																//,  
		break;
	case 1:
		DDRB|=(1<<PB5);																		//    
		if (Pulse!=0) PORTB|=(1<<PB5);														//  ,    
		else PORTB&=~(1<<PB5);																//,  
		break;
#if _DOUT-2																					//    2  s
	case 2:
		DDRB|=(1<<PB6);																		//    
		if (Pulse!=0) PORTB|=(1<<PB6);														//  ,    
		else PORTB&=~(1<<PB6);																//,  
		break;
	case 3:
		DDRB|=(1<<PB7);																		//    
		if (Pulse!=0) PORTB|=(1<<PB7);														//  ,    
		else PORTB&=~(1<<PB7);																//,  
		break;		
	case 4:
		DDRD|=(1<<PD4);																		//    
		if (Pulse!=0) PORTD|=(1<<PD4);														//  ,    
		else PORTD&=~(1<<PD4);																//,  
		break;
	case 5:
		DDRD|=(1<<PD5);																		//    
		if (Pulse!=0) PORTD|=(1<<PD5);														//  ,    
		else PORTD&=~(1<<PD5);																//,  
		break;
#if _DOUT-6																					//    2  s
	case 6:
		DDRD|=(1<<PD6);																		//    
		if (Pulse!=0) PORTD|=(1<<PD6);														//  ,    
		else PORTD&=~(1<<PD6);																//,  
		break;
	case 7:
		DDRD|=(1<<PD7);																		//    
		if (Pulse!=0) PORTD|=(1<<PD7);														//  ,    
		else PORTD&=~(1<<PD7);																//,  
		break;		
#endif
#endif
	}

	_ShimCount[Cannel]=0;																	//   
#ifdef TIMER2		
	_Timer2_Enable();																		//    2
#endif			
	sei();																					// 
	return 0;
}
#endif